#include <SoftwareSerial.h>

//Configuration du module Bluetooth
SoftwareSerial HC06 (11, 10);

//Définition des Variables
const char DOUT_CHAUFFE = 6;
const char DOUT_POMPE = 8;
String messageRecu;
int A = 10;  //Impulsion (basse) - Relais bistable
int B = 200; //Impulsion (haute) - Relais bistable
int C = 5; //Delais d'attente (1)
int D = 1; //Delais d'attente (2)

///Configuration des Entrées / Sorties
void setup ()
{
  Serial.begin (9600);
  HC06.begin (9600);
  pinMode (DOUT_CHAUFFE, OUTPUT);
  digitalWrite (DOUT_CHAUFFE, LOW);
  pinMode (DOUT_POMPE, OUTPUT);
  digitalWrite (DOUT_POMPE, LOW);
}

///Boucle infinie
void loop ()
{
  int Z = 0;
  int Y = 0;
  while (HC06.available ()) //Lecture Série Bluetooth de la consigne envoyée par Smartphone 
    {
      delay (3);
      char c = HC06.read ();
      messageRecu += c;
    }
	
  if (messageRecu.length () > 0)
    {
      Serial.println (messageRecu); //Ecriture sur le terminal COM de la consigne envoyée par Smartphone 
      
	  if (messageRecu == "CHAUFFE:1") //Impulsion - Commande Relais bistable - Activation
	{
	  digitalWrite (DOUT_CHAUFFE, HIGH); //Sortie mise à 1
	  delay (B);
	  digitalWrite (DOUT_CHAUFFE, LOW); //Sortie mise à 0
	  delay (A);
	}
      if (messageRecu == "CHAUFFE:0") //Impulsion - Commande Relais bistable - DesActivation
	{
	  digitalWrite (DOUT_CHAUFFE, HIGH); //Sortie mise à 1
	  delay (B);
	  digitalWrite (DOUT_CHAUFFE, LOW); //Sortie mise à 0
	  delay (A);
	}
      if (messageRecu == "CHAUFFE:2") //Impulsion - Commande Lancer le café
	{
	  digitalWrite (DOUT_POMPE, HIGH); //Sortie mise à 1
	  delay (A);
	}
      if (messageRecu == "CHAUFFE:3") //Impulsion - Commande Arrêter le café
	{
	  digitalWrite (DOUT_POMPE, LOW); //Sortie mise à 0
	  delay (A);
	}
      
	  
	  if (messageRecu == "AUTO") //Mode Automatique
		{
	  Serial.println ("Debut Boucle Auto"); //Ecriture sur le terminal COM de la consigne envoyée par Smartphone
	 
	 //Impulsion - Commande Relais bistable - Activation
      digitalWrite (DOUT_CHAUFFE, HIGH); //Sortie mise à 1
	  delay (B);
	  digitalWrite (DOUT_CHAUFFE, LOW); //Sortie mise à 0
	  delay (A);
	  messageRecu = "";
	  
			while (Z < 2000) //Préchauffe pendant 1 ms x 2000 = 2 s
			{
				Serial.println ("Prechauffe"); //Ecriture sur le terminal COM
				delay (D); // Attente de 1 ms
				Z++;
			}

			  Serial.println ("Début de Preparation"); //Ecriture sur le terminal COM
			  digitalWrite (DOUT_POMPE, HIGH); //Impulsion - Commande Lancer le café
			  delay (C); // Durée impulsion (haute) 5 ms
			
			while (Y < 5000) //Activation de la pompe (Lancement du café) pendant 1 ms x 5000 = 5 s
			{
				Serial.println (Y); //Ecriture sur le terminal COM du chrono
				delay (D); // Attente de 1 ms
				Y++;
			}
			  Serial.println ("Fin de Preparation"); //Ecriture sur le terminal COM
			  digitalWrite (DOUT_POMPE, LOW); //Impulsion - Commande Arrêter le café
			  delay (A); // Durée impulsion (basse) 10 ms

		}
      messageRecu = ""; 	//Reinitialisation de l'ordre Smartphone

    }
}
